#pragma once

#include <QObject>

#include <QMap>
#include <QString>
#include <QStringList>

#include <QVariant>

class QDomNode;

class CalculateConfig: public QObject
{
	Q_OBJECT
public:
	static CalculateConfig* instance();

	bool		getDefaultConfig();

	QVariant	getValue(const QString& key) const { return m_Config[key]; }
	void 		setValue(const QString& key, const QVariant& value);

	void		showInstallParameters();
	QStringList	getInstallParameters();

signals:
	void		sendParameters(QStringList);

private:
	CalculateConfig();
	~CalculateConfig();
	CalculateConfig(const CalculateConfig&);
	CalculateConfig& operator=(const CalculateConfig&);

	void parseVariables(const QDomNode& node);
	void parseVar(const QDomNode& node);
	void parseVarList(const QDomNode& node);

private:
	static CalculateConfig*	_instance;

	QMap<QString, QVariant>	m_Config;
};