#pragma once

#include "installerpage.h"

#include <QMap>

#include "commons.h"

class QLabel;
class QTreeWidget;

typedef	QList<MountPoint>				MountPointsList;
typedef QMap<QString, MountPointsList>	MountPointsTree;

class QTreeWidgetItem;

class PageMountPoints : public InstallerPage
{
	Q_OBJECT
public:
	PageMountPoints();

	bool validate();
	void retranslateUi();

public slots:
	void show();

private slots:
	void partitionDoubleClicked(QTreeWidgetItem* item, int index);

protected:
	void setupUi();

private:
	void getTree();
	void showTree();
	void showBranch(const QString& dev, const MountPointsList& list);

	void		generateCmdDisk();
	QStringList	parseMountPoint();
	QString 	parseSwap();

private:
	QLabel*			m_labMountPoints;
	QTreeWidget*	m_trwMountPoints;

	MountPointsTree m_treeMountPoints;
};